;OS-receiving code

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON

 EXTERN PutSApp,IGetKey,keyLoop,StartApp,DispHexA,ReceiveByte,SendByte,DispHexArray,myPage,tempByte
 EXTERN currentPage,currentOffset,DispHexHL,Abackup,DEbackup,HLbackup,BCbackup

ReceiveOS:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld hl,sWarning
       call PutSApp
recvKeyLoop:
       B_CALL GetKey
       cp kQuit
       jr z,StartApp
       cp kClear
       jr z,StartApp
       cp kMode
       jr z,StartApp
       cp kEnter
       jr nz,recvKeyLoop
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld hl,sReceiving
       call PutSApp
beginTransfer:
       B_CALL Get4BytesNC
       cp 68h
       jr nz,pastReady
       ld h,56h
       call Send4Bytes
       jr beginTransfer
pastReady:
       cp 06h
       jr z,$F
       B_JUMP ErrLinkXmit
$$:    B_CALL GetSmallPacket
       call DispHexArray
       ld hl,1
       ld (curRow),hl
       ld hl,sUnlocking
       call PutSApp
       ld hl,6
       ld (curRow),hl
       ld hl,sWriting
       call PutSApp
       ld hl,sUnlockName
       rst 20h
       B_CALL ChkFindSym
       jr c,errUndefined
       ld a,b
       or a
       jr z,$F
errUndefined:
       B_JUMP ErrUndefined
$$:    ex de,hl
       ld c,(hl)
       inc hl
       ld b,(hl)
       inc hl
       inc hl
       inc hl
       dec bc
       dec bc
       ld de,userMem
       di
;This WILL destroy RAM and the OS, no turning back now
       ldir
       call userMem
;Set up BCALL replacement
       ld hl,doBankedCallIX
       ld de,appBackUpScreen
       ld bc,doBankedCallIXEnd-doBankedCallIX
       ldir
;Erase all relevant Flash sectors
       xor a
       ld ix,_EraseFlashPage
       call appBackUpScreen
       ld a,4
       ld ix,_EraseFlashPage
       call appBackUpScreen
       ld a,70h
       ld ix,_EraseFlashPage
       call appBackUpScreen
       ld a,74h
       ld ix,_EraseFlashPage
       call appBackUpScreen
       ld a,78h
       ld ix,_EraseFlashPage
       call appBackUpScreen
       ld a,7Ch
       ld ix,_EraseFlashPage
       call appBackUpScreen
       ld h,9
       call Send4Bytes ;continue
       call get4Bytes ;acknowledge
;Some sort of header
       call get4Bytes ;machine ID, command, size word
       ld bc,(header+2)
headerLoop:
       push bc
       call ReceiveByte ;data byte
       pop bc
       dec bc
       ld a,b
       or c
       jr nz,headerLoop
       call ReceiveByte ;checksum
       call ReceiveByte
       ld h,56h
       call Send4Bytes ;acknowledge
       di
receiveOSLoop:
;Header packet with page/offset
       call get4Bytes ;machine ID, command, size word
       ld a,(header+1)
       cp 92h
       jr z,receiveOSDone ;EOT
       ld bc,(header+2)
       ld hl,appData
$$:    push bc
       push hl
       call ReceiveByte
       pop hl
       pop bc
       ld (hl),a
       inc hl
       dec bc
       ld a,b
       or c
       jr nz,$B
       call ReceiveByte ;checksum bytes
       call ReceiveByte
       ld h,56h
       call Send4Bytes ;acknowledge
       ld h,9
       call Send4Bytes ;continue
       call get4Bytes ;acknowledge
       ld hl,(appData+6)
       ld (currentOffset),hl
       ld a,(appData+8)
       cp 8
       jr c,$F
       push af
       in a,(2)
       and 80h
       pop bc
       ld a,b
       jr z,$F
       set 5,a
       push af
       in a,(21h)
       and 3
       pop bc
       ld a,b
       jr z,$F
       set 6,a
$$:    ld (currentPage),a
;These don't work because PutC no longer exists
;       ld hl,7
;       ld (curRow),hl
;       ld a,(currentPage)
;       call DispHexA
;       ld hl,(currentOffset)
;       call DispHexHL
;Data packet of 256 bytes to go to page/offset
       call get4Bytes ;machine ID, command, size word
       ld bc,(header+2)
       ld hl,appData
$$:    push bc
       push hl
       call ReceiveByte
       pop hl
       pop bc
       ld (hl),a
       inc hl
       dec bc
       ld a,b
       or c
       jr nz,$B
       call ReceiveByte ;checksum bytes
       call ReceiveByte
       ld de,(currentOffset)
       ld a,(currentPage)
       ld hl,appData
       ld bc,256
       ld ix,_WriteFlash
       call appBackUpScreen
       ld h,56h
       call Send4Bytes ;acknowledge
       jr receiveOSLoop
receiveOSDone:
       ld h,56h
       call Send4Bytes ;acknowledge
;       res indicOnly,(iy+indicFlags)
       jp 0000h
;       ld hl,7
;       ld (curRow),hl
;       B_CALL DispDone ;if receiving anything not TI-OS compatible, this is bad
;$$:    B_CALL GetCSC
;       or a
;       jr z,$B
;       jr StartApp
doBankedCallIX:
       ld (Abackup),a
       ld (DEbackup),de
       ld (HLbackup),hl
       ld (BCbackup),bc
       in a,(6)
       push af
       ld a,7Fh
       call translatePage
       out (6),a
       push ix
       pop hl
       res 7,h
       set 6,h
       ld e,(hl)
       inc hl
       ld d,(hl)
       push de
       pop ix
       ld de,returnPoint-doBankedCallIX+appBackUpScreen
       push de
       ld a,(Abackup)
       ld de,(DEbackup)
       ld hl,(HLbackup)
       ld bc,(BCbackup)
       jp (ix)
returnPoint:
       pop af
       out (6),a
       ret
doBankedCallIXEnd:
translatePage:
       push af
       in a,(2)
       and 80h
       pop bc
       ld a,b
       jr z,_83pPage
       push af
       in a,(21h)
       and 3
       pop bc
       ld a,b
       ret nz
       and 3Fh
       ret
_83pPage:
       and 1Fh
       ret
get4Bytes:
       call ReceiveByte
       ld (header),a
       call ReceiveByte
       ld (header+1),a
       call ReceiveByte
       ld (header+2),a
       call ReceiveByte
       ld (header+3),a
       ret
Send4Bytes:
       push hl
       ld a,73h
       call SendByte
       pop af
       call SendByte
       xor a
       call SendByte
       xor a
       jr SendByte
sWarning:
       DB "!!!!WARNING!!!!!"
       DB "                "
       DB "Make sure that  "
       DB "prgmUNLOCK is   "
       DB "correct and then"
       DB "press ",LlBrack,"ENTER] to"
       DB "continue.",0
sUnlocking:
       DB "Unlocking",0CEh,0
sReceiving:
       DB "Receiving",0CEh,0
sWriting:
       DB "DO NOT INTERRUPT",0
sUnlockName:
       DB ProtProgObj,"UNLOCK",0
